/*******************************************************************************
 * FoxDestructible generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxDestructible extends KActor
    abstract
    native(Destructible);

struct native DebrisPiece
{
    var() const StaticMesh DebrisMesh;
    var() Vector SpawnOffset;
    var() float Impulse;
    var() float LifeSpan;

    structdefaultproperties
    {
        DebrisMesh=none
        SpawnOffset=(X=0.0,Y=0.0,Z=0.0)
        Impulse=1.0
        LifeSpan=15.0
    }
};

struct native DamageStage
{
    var() const StaticMesh DamagedMesh;
    var() const MaterialInterface DamagedMaterial;
    var() const ParticleSystem StageTransitionTemplate;
    var() const Vector StageTransitionOffset;
    var() float Impulse;
    var() float HealthThresholdPct;
    var() array<DebrisPiece> Debris;
    var() int AwardPoints;

    structdefaultproperties
    {
        DamagedMesh=none
        DamagedMaterial=none
        StageTransitionTemplate=none
        StageTransitionOffset=(X=0.0,Y=0.0,Z=0.0)
        Impulse=0.0
        HealthThresholdPct=0.0
        Debris=none
        AwardPoints=50
    }
};

var() array<DamageStage> DamageStages;
var repnotify transient byte CurrentStage;
var() const ParticleSystem BurningParticleSystemTemplate;
var transient Emitter BurnEmitter;
var() const float BurnDamagePerSecond;
var() float BurnThresholdPct;
var repnotify transient bool bHasBeganBurning;
var() bool bDisablePhysics;
var() const bool bShowInHRV;
var() int Health;
var transient Controller LastPersonToDamageUs;
var StaticMesh CashedOriginalMesh;
var() float Damage;
var() float DamageRadiusInner;
var() float DamageRadiusOuter;
var float MomentumTransfer;
var class<DamageType> ExplosionDamageType;
var() export editinline DrawSphereComponent DrawDamageRadiusInner;
var() export editinline DrawSphereComponent DrawDamageRadiusOuter;
var() float RespawnTime;
var() float RadiusDamageExplodePercentage;
var() const Material HRVMaterial;

replication
{
    // Pos:0x000
    if(Role == ROLE_Authority)
        CurrentStage, bHasBeganBurning
}

simulated event PostBeginPlay()
{
    // End:0x12
    if(bDisablePhysics)
    {
        SetPhysics(0);
    }
    CashedOriginalMesh = StaticMeshComponent.StaticMesh;
    super.PostBeginPlay();
    //return;    
}

simulated event ReplicatedEvent(name VarName)
{
    // End:0x4C
    if((VarName == 'CurrentStage') && CurrentStage > 0)
    {
        ChangeDamageStage(CurrentStage - 1, none);
    }
    // End:0x90
    else
    {
        // End:0x7D
        if(VarName == 'bHasBeganBurning')
        {
            // End:0x7A
            if(bHasBeganBurning)
            {
                BeginBurning();
            }
        }
        // End:0x90
        else
        {
            super.ReplicatedEvent(VarName);
        }
    }
    //return;    
}

simulated event ToggleHRVEffects(const bool bEnabled)
{
    local int I;

    // End:0x156
    if(bShowInHRV && StaticMeshComponent != none)
    {
        // End:0xC6
        if(bEnabled)
        {
            I = 0;
            J0x36:
            // End:0xA2 [Loop If]
            if(I < StaticMeshComponent.GetNumElements())
            {
                StaticMeshComponent.SetMaterial(I, HRVMaterial);
                ++ I;
                // [Loop Continue]
                goto J0x36;
            }
            StaticMeshComponent.SetDepthPriorityGroup(2);
        }
        // End:0x156
        else
        {
            I = 0;
            J0xD1:
            // End:0x135 [Loop If]
            if(I < StaticMeshComponent.GetNumElements())
            {
                StaticMeshComponent.SetMaterial(I, none);
                ++ I;
                // [Loop Continue]
                goto J0xD1;
            }
            StaticMeshComponent.SetDepthPriorityGroup(1);
        }
    }
    //return;    
}

event TakeDamage(int DamageAmount, Controller EventInstigator, Vector HitLocation, Vector Momentum, class<DamageType> DamageType, optional TraceHitInfo HitInfo, optional Actor DamageCauser)
{
    local int MaxDamageStages;
    local FoxPhysicalMaterialProperty FoxPhyMatPro;

    // End:0xB2
    if(HitInfo.PhysMaterial != none)
    {
        FoxPhyMatPro = FoxPhysicalMaterialProperty(HitInfo.PhysMaterial.PhysicalMaterialProperty);
        // End:0xB2
        if(FoxPhyMatPro != none)
        {
            DamageAmount = FoxPhyMatPro.ModifyDamageBasedOnMaterial(DamageAmount, DamageType);
        }
    }
    super.TakeDamage(DamageAmount, EventInstigator, HitLocation, Momentum, DamageType, HitInfo, DamageCauser);
    // End:0x240
    if(DamageAmount > 0)
    {
        LastPersonToDamageUs = EventInstigator;
        // End:0x144
        if((Role < ROLE_Authority) || Health <= 0)
        {
            return;
        }
        Health -= DamageAmount;
        MaxDamageStages = DamageStages.Length;
        // End:0x1F3
        if(CurrentStage < MaxDamageStages)
        {
            // End:0x1F3
            if((DamageStages[CurrentStage].HealthThresholdPct * float(default.Health)) >= float(Health))
            {
                ChangeDamageStage(CurrentStage, EventInstigator);
                ++ CurrentStage;
            }
        }
        // End:0x240
        if(!bHasBeganBurning && (BurnThresholdPct * float(default.Health)) > float(Health))
        {
            bHasBeganBurning = true;
            BeginBurning();
        }
    }
    //return;    
}

simulated function TakeRadiusDamage(Controller InstigatedBy, float BaseDamage, float DamageRadius, class<DamageType> DamageType, float Momentum, Vector HurtOrigin, bool bFullDamage, Actor DamageCauser, optional float DamageFalloffExponent)
{
    local float ColRadius, ColHeight, DamageScale, Dist;
    local Vector Dir;

    DamageFalloffExponent = 1.0;
    GetBoundingCylinder(ColRadius, ColHeight);
    Dir = Location - HurtOrigin;
    Dist = VSize(Dir);
    Dir = Normal(Dir);
    Dist = FClamp(Dist - ColRadius, 0.0, DamageRadius);
    DamageScale = 1.0 - (Dist / DamageRadius);
    // End:0xF5
    if(bFullDamage || DamageScale > RadiusDamageExplodePercentage)
    {
        DamageScale = 1.0;
    }
    // End:0x194
    if(DamageScale > 0.0)
    {
        TakeDamage(int(BaseDamage * DamageScale), InstigatedBy, Location - ((0.50 * (ColHeight + ColRadius)) * Dir), (DamageScale * Momentum) * Dir, DamageType,, DamageCauser);
    }
    //return;    
}

simulated function BeginBurning()
{
    // End:0xD5
    if(WorldInfo.NetMode != NM_DedicatedServer)
    {
        BurnEmitter = FoxGRI(WorldInfo.GRI).ObjectPool.GetEmitter(BurningParticleSystemTemplate, Location, Rotation);
        BurnEmitter.ParticleSystemComponent.ActivateSystem();
    }
    // End:0xFC
    if(Role == ROLE_Authority)
    {
        SetTimer(1.0, true, 'TakeBurnDamage');
    }
    //return;    
}

function TakeBurnDamage()
{
    TakeDamage(int(BurnDamagePerSecond), LastPersonToDamageUs, vect(0.0, 0.0, 0.0), vect(0.0, 0.0, 0.0), class'FoxDamageType_Fire');
    //return;    
}

simulated function ChangeDamageStage(int Index, Controller EventInstigator)
{
    local int I, iActiveDecalInfo;
    local bool bLastStage;
    local Vector SpawnLocation, SpawnOffset, ImpulseDir;
    local KActor NewDebris;
    local Emitter DamageEmitter;
    local FoxPC PC;

    // End:0x1A
    if(Index >= DamageStages.Length)
    {
        return;
    }
    // End:0x52B
    if(WorldInfo.NetMode != NM_DedicatedServer)
    {
        // End:0x138
        if(DamageStages[Index].StageTransitionTemplate != none)
        {
            DamageEmitter = FoxGRI(WorldInfo.GRI).ObjectPool.GetEmitter(DamageStages[Index].StageTransitionTemplate, Location, Rotation);
            DamageEmitter.ParticleSystemComponent.ActivateSystem();
        }
        I = 0;
        J0x143:
        // End:0x52B [Loop If]
        if(I < DamageStages[Index].Debris.Length)
        {
            SpawnOffset = DamageStages[Index].Debris[I].SpawnOffset;
            // End:0x246
            if(VSize(SpawnOffset) == float(0))
            {
                SpawnOffset.X = FRand() * 0.250;
                SpawnOffset.Y = FRand() * 0.250;
                SpawnOffset.Z = 1.0;
            }
            SpawnLocation = Location - (SpawnOffset >> Rotation);
            NewDebris = FoxGRI(WorldInfo.GRI).ObjectPool.GetKActorSpawnable(SpawnLocation, rot(0, 0, 0), DamageStages[Index].Debris[I].LifeSpan);
            // End:0x51D
            if(NewDebris != none)
            {
                NewDebris.StaticMeshComponent.SetStaticMesh(DamageStages[Index].Debris[I].DebrisMesh);
                NewDebris.RemoteRole = ROLE_None;
                NewDebris.StaticMeshComponent.WakeRigidBody();
                NewDebris.SetCollision(true, false);
                // End:0x51D
                if(DamageStages[Index].Debris[I].Impulse > float(0))
                {
                    ImpulseDir = Normal(Location - SpawnLocation);
                    ImpulseDir += (ImpulseDir * (0.50 - FRand()));
                    NewDebris.ApplyImpulse(ImpulseDir, DamageStages[Index].Debris[I].Impulse, SpawnLocation);
                }
            }
            ++ I;
            // [Loop Continue]
            goto J0x143;
        }
    }
    bLastStage = Index == (DamageStages.Length - 1);
    // End:0x582
    if(bLastStage)
    {
        ClearTimer('TakeBurnDamage');
        SetTimer(2.0, false, 'TurnOffBurning');
    }
    // End:0x627
    if(!bDisablePhysics && DamageStages[Index].Impulse > float(0))
    {
        ImpulseDir = vect(0.250, 0.250, 1.0) * (0.50 - FRand());
        ApplyImpulse(ImpulseDir, DamageStages[Index].Impulse, Location);
    }
    // End:0xAC3
    if(Role == ROLE_Authority)
    {
        // End:0x6BB
        if(DamageStages[Index].DamagedMesh != none)
        {
            StaticMeshComponent.SetMaterial(0, none);
            SetStaticMesh(DamageStages[Index].DamagedMesh);
        }
        // End:0x75D
        if(DamageStages[Index].DamagedMaterial != none)
        {
            StaticMeshComponent.SetMaterial(0, DamageStages[Index].DamagedMaterial);
            ReplicatedMaterial0 = DamageStages[Index].DamagedMaterial;
        }
        // End:0x8AA
        if(WorldInfo.NetMode != NM_DedicatedServer)
        {
            iActiveDecalInfo = 0;
            J0x791:
            // End:0x8AA [Loop If]
            if(iActiveDecalInfo < WorldInfo.MyDecalManager.ActiveDecals.Length)
            {
                // End:0x89C
                if(WorldInfo.MyDecalManager.ActiveDecals[iActiveDecalInfo].Decal.HitComponent == StaticMeshComponent)
                {
                    WorldInfo.MyDecalManager.ActiveDecals[iActiveDecalInfo].LifetimeRemaining = 0.0;
                }
                ++ iActiveDecalInfo;
                // [Loop Continue]
                goto J0x791;
            }
        }
        // End:0x8D8
        if(bLastStage)
        {
            HurtDoubleRadius();
            SetTimer(RespawnTime, false, 'Reset');
        }
        // End:0xAC3
        if(DamageStages[Index].AwardPoints > 0)
        {
            // End:0xA5F
            if(FoxPC(EventInstigator) != none)
            {
                FoxPC(EventInstigator).ClientNotifyDestructibleDestroyed(DamageStages[Index].AwardPoints);
                // End:0xA5F
                if((Role == ROLE_Authority) && EventInstigator.Pawn != none)
                {
                    // End:0xA5E
                    foreach WorldInfo.AllControllers(class'FoxPC', PC)
                    {
                        // End:0xA5D
                        if(EventInstigator.Pawn.IsBeingFPSpectatedBy(PC))
                        {
                            PC.ClientNotifySpectateDestructibleDestroyed(DamageStages[Index].AwardPoints);
                        }                        
                    }                    
                }
            }
            FoxPRI(EventInstigator.PlayerReplicationInfo).AddCombatPoints(DamageStages[Index].AwardPoints);
        }
    }
    //return;    
}

simulated function TurnOffBurning()
{
    // End:0x39
    if(BurnEmitter != none)
    {
        BurnEmitter.ShutDown();
        BurnEmitter = none;
    }
    //return;    
}

simulated function Reset()
{
    // End:0x8B
    if(Role == ROLE_Authority)
    {
        CurrentStage = 0;
        bHasBeganBurning = false;
        Health = default.Health;
        LastPersonToDamageUs = none;
        StaticMeshComponent.SetMaterial(0, none);
        SetStaticMesh(CashedOriginalMesh);
        TurnOffBurning();
    }
    super.Reset();
    //return;    
}

simulated function HurtVictimDoubleRadiusDamage(Actor Victim, Vector HurtOrigin)
{
    local float ColRadius, ColHeight, DamageScale, Dist;
    local Vector Dir;

    Victim.GetBoundingCylinder(ColRadius, ColHeight);
    Dir = Victim.Location - HurtOrigin;
    Dist = VSize(Dir);
    Dir = Normal(Dir);
    // End:0xB7
    if(Dist < DamageRadiusInner)
    {
        DamageScale = 1.0;
    }
    // End:0x143
    else
    {
        // End:0x134
        if(DamageRadiusOuter != 0.0)
        {
            Dist -= DamageRadiusInner;
            Dist = FClamp(Dist - ColRadius, 0.0, DamageRadiusOuter);
            DamageScale = 1.0 - (Dist / DamageRadiusOuter);
        }
        // End:0x143
        else
        {
            DamageScale = 0.0;
        }
    }
    // End:0x204
    if(DamageScale > 0.0)
    {
        Victim.TakeDamage(int(DamageScale * Damage), LastPersonToDamageUs, Victim.Location - ((0.50 * (ColHeight + ColRadius)) * Dir), (DamageScale * MomentumTransfer) * Dir, ExplosionDamageType,, self);
    }
    //return;    
}

singular simulated function HurtDoubleRadius()
{
    local Actor Victim;

    // End:0xC0
    foreach VisibleCollidingActors(class'Actor', Victim, DamageRadiusOuter, Location)
    {
        // End:0xBF
        if((!Victim.bWorldGeometry && Victim != self) && Victim.bProjTarget || NavigationPoint(Victim) == none)
        {
            HurtVictimDoubleRadiusDamage(Victim, Location);
        }        
    }    
    //return;    
}

defaultproperties
{
    BurnDamagePerSecond=10.0
    Health=100
    Damage=40.0
    DamageRadiusInner=200.0
    DamageRadiusOuter=600.0
    MomentumTransfer=1.0
    ExplosionDamageType=class'FoxDamageType_Explosion'
    begin object name=DrawSphere2 class=DrawSphereComponent
        SphereRadius=200.0
        ReplacementPrimitive=none
    object end
    // Reference: DrawSphereComponent'Default__FoxDestructible.DrawSphere2'
    DrawDamageRadiusInner=DrawSphere2
    begin object name=DrawSphere1 class=DrawSphereComponent
        SphereColor=(R=255,G=128,B=0,A=255)
        SphereRadius=600.0
        ReplacementPrimitive=none
    object end
    // Reference: DrawSphereComponent'Default__FoxDestructible.DrawSphere1'
    DrawDamageRadiusOuter=DrawSphere1
    RespawnTime=60.0
    RadiusDamageExplodePercentage=0.50
    HRVMaterial=Material'FX_Characters.MT.MT_HVT_Noise'
    begin object name=StaticMeshComponent0 class=StaticMeshComponent
        ReplacementPrimitive=none
        LightEnvironment=DynamicLightEnvironmentComponent'Default__FoxDestructible.MyLightEnvironment'
    object end
    // Reference: StaticMeshComponent'Default__FoxDestructible.StaticMeshComponent0'
    StaticMeshComponent=StaticMeshComponent0
    LightEnvironment=DynamicLightEnvironmentComponent'Default__FoxDestructible.MyLightEnvironment'
    Components(0)=DynamicLightEnvironmentComponent'Default__FoxDestructible.MyLightEnvironment'
    begin object name=StaticMeshComponent0 class=StaticMeshComponent
        ReplacementPrimitive=none
        LightEnvironment=DynamicLightEnvironmentComponent'Default__FoxDestructible.MyLightEnvironment'
    object end
    // Reference: StaticMeshComponent'Default__FoxDestructible.StaticMeshComponent0'
    Components(1)=StaticMeshComponent0
    begin object name=DrawSphere2 class=DrawSphereComponent
        SphereRadius=200.0
        ReplacementPrimitive=none
    object end
    // Reference: DrawSphereComponent'Default__FoxDestructible.DrawSphere2'
    Components(2)=DrawSphere2
    begin object name=DrawSphere1 class=DrawSphereComponent
        SphereColor=(R=255,G=128,B=0,A=255)
        SphereRadius=600.0
        ReplacementPrimitive=none
    object end
    // Reference: DrawSphereComponent'Default__FoxDestructible.DrawSphere1'
    Components(3)=DrawSphere1
    CollisionType=ECollisionType.COLLIDE_BlockAll
    begin object name=StaticMeshComponent0 class=StaticMeshComponent
        ReplacementPrimitive=none
        LightEnvironment=DynamicLightEnvironmentComponent'Default__FoxDestructible.MyLightEnvironment'
    object end
    // Reference: StaticMeshComponent'Default__FoxDestructible.StaticMeshComponent0'
    CollisionComponent=StaticMeshComponent0
}